Fixed ticet #277: GUID generation cannot generate more than 2^16 unique numbers (thanks Igor Sobinov)

git-svn-id: https://svn.pjsip.org/repos/pjproject/trunk@1282 74dad513-b988-da41-8d7b-12977e46ad98
This commit is contained in:
Benny Prijono 2007-05-16 13:41:00 +00:00
parent 48da92eec9
commit 4e48b516da
5 changed files with 357 additions and 6 deletions

View File

@ -3340,6 +3340,148 @@ _ACEOF
fi
echo "$as_me:$LINENO: checking for uuid_generate in -luuid" >&5
echo $ECHO_N "checking for uuid_generate in -luuid... $ECHO_C" >&6
if test "${ac_cv_lib_uuid_uuid_generate+set}" = set; then
echo $ECHO_N "(cached) $ECHO_C" >&6
else
ac_check_lib_save_LIBS=$LIBS
LIBS="-luuid $LIBS"
cat >conftest.$ac_ext <<_ACEOF
/* confdefs.h. */
_ACEOF
cat confdefs.h >>conftest.$ac_ext
cat >>conftest.$ac_ext <<_ACEOF
/* end confdefs.h. */
/* Override any gcc2 internal prototype to avoid an error. */
#ifdef __cplusplus
extern "C"
#endif
/* We use char because int might match the return type of a gcc2
builtin and then its argument prototype would still apply. */
char uuid_generate ();
int
main ()
{
uuid_generate ();
;
return 0;
}
_ACEOF
rm -f conftest.$ac_objext conftest$ac_exeext
if { (eval echo "$as_me:$LINENO: \"$ac_link\"") >&5
(eval $ac_link) 2>conftest.er1
ac_status=$?
grep -v '^ *+' conftest.er1 >conftest.err
rm -f conftest.er1
cat conftest.err >&5
echo "$as_me:$LINENO: \$? = $ac_status" >&5
(exit $ac_status); } &&
{ ac_try='test -z "$ac_c_werror_flag"
|| test ! -s conftest.err'
{ (eval echo "$as_me:$LINENO: \"$ac_try\"") >&5
(eval $ac_try) 2>&5
ac_status=$?
echo "$as_me:$LINENO: \$? = $ac_status" >&5
(exit $ac_status); }; } &&
{ ac_try='test -s conftest$ac_exeext'
{ (eval echo "$as_me:$LINENO: \"$ac_try\"") >&5
(eval $ac_try) 2>&5
ac_status=$?
echo "$as_me:$LINENO: \$? = $ac_status" >&5
(exit $ac_status); }; }; then
ac_cv_lib_uuid_uuid_generate=yes
else
echo "$as_me: failed program was:" >&5
sed 's/^/| /' conftest.$ac_ext >&5
ac_cv_lib_uuid_uuid_generate=no
fi
rm -f conftest.err conftest.$ac_objext \
conftest$ac_exeext conftest.$ac_ext
LIBS=$ac_check_lib_save_LIBS
fi
echo "$as_me:$LINENO: result: $ac_cv_lib_uuid_uuid_generate" >&5
echo "${ECHO_T}$ac_cv_lib_uuid_uuid_generate" >&6
if test $ac_cv_lib_uuid_uuid_generate = yes; then
cat >>confdefs.h <<_ACEOF
#define HAVE_LIBUUID 1
_ACEOF
LIBS="-luuid $LIBS"
fi
echo "$as_me:$LINENO: checking for uuid_generate in -luuid" >&5
echo $ECHO_N "checking for uuid_generate in -luuid... $ECHO_C" >&6
if test "${ac_cv_lib_uuid_uuid_generate+set}" = set; then
echo $ECHO_N "(cached) $ECHO_C" >&6
else
ac_check_lib_save_LIBS=$LIBS
LIBS="-luuid $LIBS"
cat >conftest.$ac_ext <<_ACEOF
/* confdefs.h. */
_ACEOF
cat confdefs.h >>conftest.$ac_ext
cat >>conftest.$ac_ext <<_ACEOF
/* end confdefs.h. */
/* Override any gcc2 internal prototype to avoid an error. */
#ifdef __cplusplus
extern "C"
#endif
/* We use char because int might match the return type of a gcc2
builtin and then its argument prototype would still apply. */
char uuid_generate ();
int
main ()
{
uuid_generate ();
;
return 0;
}
_ACEOF
rm -f conftest.$ac_objext conftest$ac_exeext
if { (eval echo "$as_me:$LINENO: \"$ac_link\"") >&5
(eval $ac_link) 2>conftest.er1
ac_status=$?
grep -v '^ *+' conftest.er1 >conftest.err
rm -f conftest.er1
cat conftest.err >&5
echo "$as_me:$LINENO: \$? = $ac_status" >&5
(exit $ac_status); } &&
{ ac_try='test -z "$ac_c_werror_flag"
|| test ! -s conftest.err'
{ (eval echo "$as_me:$LINENO: \"$ac_try\"") >&5
(eval $ac_try) 2>&5
ac_status=$?
echo "$as_me:$LINENO: \$? = $ac_status" >&5
(exit $ac_status); }; } &&
{ ac_try='test -s conftest$ac_exeext'
{ (eval echo "$as_me:$LINENO: \"$ac_try\"") >&5
(eval $ac_try) 2>&5
ac_status=$?
echo "$as_me:$LINENO: \$? = $ac_status" >&5
(exit $ac_status); }; }; then
ac_cv_lib_uuid_uuid_generate=yes
else
echo "$as_me: failed program was:" >&5
sed 's/^/| /' conftest.$ac_ext >&5
ac_cv_lib_uuid_uuid_generate=no
fi
rm -f conftest.err conftest.$ac_objext \
conftest$ac_exeext conftest.$ac_ext
LIBS=$ac_check_lib_save_LIBS
fi
echo "$as_me:$LINENO: result: $ac_cv_lib_uuid_uuid_generate" >&5
echo "${ECHO_T}$ac_cv_lib_uuid_uuid_generate" >&6
if test $ac_cv_lib_uuid_uuid_generate = yes; then
ac_has_uuid_lib=1
fi
echo "$as_me:$LINENO: result: Setting PJ_M_NAME to $target_cpu" >&5
echo "${ECHO_T}Setting PJ_M_NAME to $target_cpu" >&6
cat >>confdefs.h <<_ACEOF
@ -8013,6 +8155,148 @@ _ACEOF
fi
if test "${ac_cv_header_uuid_uuid_h+set}" = set; then
echo "$as_me:$LINENO: checking for uuid/uuid.h" >&5
echo $ECHO_N "checking for uuid/uuid.h... $ECHO_C" >&6
if test "${ac_cv_header_uuid_uuid_h+set}" = set; then
echo $ECHO_N "(cached) $ECHO_C" >&6
fi
echo "$as_me:$LINENO: result: $ac_cv_header_uuid_uuid_h" >&5
echo "${ECHO_T}$ac_cv_header_uuid_uuid_h" >&6
else
# Is the header compilable?
echo "$as_me:$LINENO: checking uuid/uuid.h usability" >&5
echo $ECHO_N "checking uuid/uuid.h usability... $ECHO_C" >&6
cat >conftest.$ac_ext <<_ACEOF
/* confdefs.h. */
_ACEOF
cat confdefs.h >>conftest.$ac_ext
cat >>conftest.$ac_ext <<_ACEOF
/* end confdefs.h. */
$ac_includes_default
#include <uuid/uuid.h>
_ACEOF
rm -f conftest.$ac_objext
if { (eval echo "$as_me:$LINENO: \"$ac_compile\"") >&5
(eval $ac_compile) 2>conftest.er1
ac_status=$?
grep -v '^ *+' conftest.er1 >conftest.err
rm -f conftest.er1
cat conftest.err >&5
echo "$as_me:$LINENO: \$? = $ac_status" >&5
(exit $ac_status); } &&
{ ac_try='test -z "$ac_c_werror_flag"
|| test ! -s conftest.err'
{ (eval echo "$as_me:$LINENO: \"$ac_try\"") >&5
(eval $ac_try) 2>&5
ac_status=$?
echo "$as_me:$LINENO: \$? = $ac_status" >&5
(exit $ac_status); }; } &&
{ ac_try='test -s conftest.$ac_objext'
{ (eval echo "$as_me:$LINENO: \"$ac_try\"") >&5
(eval $ac_try) 2>&5
ac_status=$?
echo "$as_me:$LINENO: \$? = $ac_status" >&5
(exit $ac_status); }; }; then
ac_header_compiler=yes
else
echo "$as_me: failed program was:" >&5
sed 's/^/| /' conftest.$ac_ext >&5
ac_header_compiler=no
fi
rm -f conftest.err conftest.$ac_objext conftest.$ac_ext
echo "$as_me:$LINENO: result: $ac_header_compiler" >&5
echo "${ECHO_T}$ac_header_compiler" >&6
# Is the header present?
echo "$as_me:$LINENO: checking uuid/uuid.h presence" >&5
echo $ECHO_N "checking uuid/uuid.h presence... $ECHO_C" >&6
cat >conftest.$ac_ext <<_ACEOF
/* confdefs.h. */
_ACEOF
cat confdefs.h >>conftest.$ac_ext
cat >>conftest.$ac_ext <<_ACEOF
/* end confdefs.h. */
#include <uuid/uuid.h>
_ACEOF
if { (eval echo "$as_me:$LINENO: \"$ac_cpp conftest.$ac_ext\"") >&5
(eval $ac_cpp conftest.$ac_ext) 2>conftest.er1
ac_status=$?
grep -v '^ *+' conftest.er1 >conftest.err
rm -f conftest.er1
cat conftest.err >&5
echo "$as_me:$LINENO: \$? = $ac_status" >&5
(exit $ac_status); } >/dev/null; then
if test -s conftest.err; then
ac_cpp_err=$ac_c_preproc_warn_flag
ac_cpp_err=$ac_cpp_err$ac_c_werror_flag
else
ac_cpp_err=
fi
else
ac_cpp_err=yes
fi
if test -z "$ac_cpp_err"; then
ac_header_preproc=yes
else
echo "$as_me: failed program was:" >&5
sed 's/^/| /' conftest.$ac_ext >&5
ac_header_preproc=no
fi
rm -f conftest.err conftest.$ac_ext
echo "$as_me:$LINENO: result: $ac_header_preproc" >&5
echo "${ECHO_T}$ac_header_preproc" >&6
# So? What about this header?
case $ac_header_compiler:$ac_header_preproc:$ac_c_preproc_warn_flag in
yes:no: )
{ echo "$as_me:$LINENO: WARNING: uuid/uuid.h: accepted by the compiler, rejected by the preprocessor!" >&5
echo "$as_me: WARNING: uuid/uuid.h: accepted by the compiler, rejected by the preprocessor!" >&2;}
{ echo "$as_me:$LINENO: WARNING: uuid/uuid.h: proceeding with the compiler's result" >&5
echo "$as_me: WARNING: uuid/uuid.h: proceeding with the compiler's result" >&2;}
ac_header_preproc=yes
;;
no:yes:* )
{ echo "$as_me:$LINENO: WARNING: uuid/uuid.h: present but cannot be compiled" >&5
echo "$as_me: WARNING: uuid/uuid.h: present but cannot be compiled" >&2;}
{ echo "$as_me:$LINENO: WARNING: uuid/uuid.h: check for missing prerequisite headers?" >&5
echo "$as_me: WARNING: uuid/uuid.h: check for missing prerequisite headers?" >&2;}
{ echo "$as_me:$LINENO: WARNING: uuid/uuid.h: see the Autoconf documentation" >&5
echo "$as_me: WARNING: uuid/uuid.h: see the Autoconf documentation" >&2;}
{ echo "$as_me:$LINENO: WARNING: uuid/uuid.h: section \"Present But Cannot Be Compiled\"" >&5
echo "$as_me: WARNING: uuid/uuid.h: section \"Present But Cannot Be Compiled\"" >&2;}
{ echo "$as_me:$LINENO: WARNING: uuid/uuid.h: proceeding with the preprocessor's result" >&5
echo "$as_me: WARNING: uuid/uuid.h: proceeding with the preprocessor's result" >&2;}
{ echo "$as_me:$LINENO: WARNING: uuid/uuid.h: in the future, the compiler will take precedence" >&5
echo "$as_me: WARNING: uuid/uuid.h: in the future, the compiler will take precedence" >&2;}
(
cat <<\_ASBOX
## ------------------------------------ ##
## Report this to the pjproject lists. ##
## ------------------------------------ ##
_ASBOX
) |
sed "s/^/$as_me: WARNING: /" >&2
;;
esac
echo "$as_me:$LINENO: checking for uuid/uuid.h" >&5
echo $ECHO_N "checking for uuid/uuid.h... $ECHO_C" >&6
if test "${ac_cv_header_uuid_uuid_h+set}" = set; then
echo $ECHO_N "(cached) $ECHO_C" >&6
else
ac_cv_header_uuid_uuid_h=$ac_header_preproc
fi
echo "$as_me:$LINENO: result: $ac_cv_header_uuid_uuid_h" >&5
echo "${ECHO_T}$ac_cv_header_uuid_uuid_h" >&6
fi
if test $ac_cv_header_uuid_uuid_h = yes; then
ac_has_uuid_h=1
fi
echo "$as_me:$LINENO: result: Setting PJ_OS_NAME to $target" >&5
echo "${ECHO_T}Setting PJ_OS_NAME to $target" >&6
@ -8355,13 +8639,20 @@ case $target in
ac_os_objs="file_access_win32.o file_io_win32.o os_core_win32.o os_error_win32.o os_time_win32.o os_timestamp_win32.o guid_win32.o ioqueue_select.o"
;;
*)
ac_os_objs="file_access_unistd.o file_io_ansi.o os_core_unix.o os_error_unix.o os_time_unix.o os_timestamp_posix.o guid_simple.o ioqueue_select.o"
ac_os_objs="file_access_unistd.o file_io_ansi.o os_core_unix.o os_error_unix.o os_time_unix.o os_timestamp_posix.o ioqueue_select.o"
# UUID
if test "$ac_has_uuid_lib" = "1" -a "$ac_has_uuid_h" = "1"; then
ac_os_objs="$ac_os_objs guid_uuid.o"
else
ac_os_objs="$ac_os_objs guid_simple.o"
fi
;;
esac
# Check whether --enable-sound or --disable-sound was given.
if test "${enable_sound+set}" = set; then
enableval="$enable_sound"

View File

@ -48,6 +48,8 @@ AC_CHECK_LIB(winmm,puts)
AC_CHECK_LIB(socket,puts)
AC_CHECK_LIB(rt,puts)
AC_CHECK_LIB(nsl,puts)
AC_CHECK_LIB(uuid,uuid_generate)
AC_CHECK_LIB(uuid,uuid_generate,[ac_has_uuid_lib=1])
AC_MSG_RESULT([Setting PJ_M_NAME to $target_cpu])
AC_DEFINE_UNQUOTED(PJ_M_NAME,["$target_cpu"])
@ -151,6 +153,7 @@ AC_CHECK_HEADER(unistd.h,[AC_DEFINE(PJ_HAS_UNISTD_H,1)])
AC_CHECK_HEADER(mswsock.h,[AC_DEFINE(PJ_HAS_MSWSOCK_H,1)])
AC_CHECK_HEADER(winsock.h,[AC_DEFINE(PJ_HAS_WINSOCK_H,1)])
AC_CHECK_HEADER(winsock2.h,[AC_DEFINE(PJ_HAS_WINSOCK2_H,1)])
AC_CHECK_HEADER(uuid/uuid.h,[ac_has_uuid_h=1])
AC_MSG_RESULT([Setting PJ_OS_NAME to $target])
AC_DEFINE_UNQUOTED(PJ_OS_NAME,["$target"])
@ -232,11 +235,18 @@ case $target in
ac_os_objs="file_access_win32.o file_io_win32.o os_core_win32.o os_error_win32.o os_time_win32.o os_timestamp_win32.o guid_win32.o ioqueue_select.o"
;;
*)
ac_os_objs="file_access_unistd.o file_io_ansi.o os_core_unix.o os_error_unix.o os_time_unix.o os_timestamp_posix.o guid_simple.o ioqueue_select.o"
ac_os_objs="file_access_unistd.o file_io_ansi.o os_core_unix.o os_error_unix.o os_time_unix.o os_timestamp_posix.o ioqueue_select.o"
# UUID
if test "$ac_has_uuid_lib" = "1" -a "$ac_has_uuid_h" = "1"; then
ac_os_objs="$ac_os_objs guid_uuid.o"
else
ac_os_objs="$ac_os_objs guid_simple.o"
fi
;;
esac
dnl ##########################################
dnl #
dnl # PJMEDIA

View File

@ -48,10 +48,13 @@ PJ_BEGIN_DECL
/**
* PJ_GUID_STRING_LENGTH specifies length of GUID string. The value is
* dependent on the algorithm used internally to generate the GUID string.
* If real GUID generator is used, then the length will be 128bit or
* 32 bytes. If shadow GUID generator is used, then the length
* If real GUID generator is used, then the length will be between 32 and
* 36 bytes. If shadow GUID generator is used, then the length
* will be 20 bytes. Application should not assume which algorithm will
* be used by GUID generator.
*
* Regardless of the actual length of the GUID, it will not exceed
* PJ_GUID_MAX_LENGTH characters.
*/
extern const unsigned PJ_GUID_STRING_LENGTH;
@ -59,7 +62,7 @@ extern const unsigned PJ_GUID_STRING_LENGTH;
* PJ_GUID_MAX_LENGTH specifies the maximum length of GUID string,
* regardless of which algorithm to use.
*/
#define PJ_GUID_MAX_LENGTH 32
#define PJ_GUID_MAX_LENGTH 36
/**
* Create a globally unique string, which length is PJ_GUID_STRING_LENGTH

View File

@ -21,7 +21,7 @@
#include <pj/ioqueue.h>
static const char *id = "config.c";
const char *PJ_VERSION = "0.7.0-rc1";
const char *PJ_VERSION = "0.7.0-pre-rc2";
PJ_DEF(void) pj_dump_config(void)
{

47
pjlib/src/pj/guid_uuid.c Normal file
View File

@ -0,0 +1,47 @@
/* $Id$ */
/*
* Copyright (C)2003-2007 Benny Prijono <benny@prijono.org>
*
* This program is free software; you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License, or
* (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
*/
#include <pj/guid.h>
#include <pj/assert.h>
#include <pj/errno.h>
#include <pj/os.h>
#include <pj/string.h>
#include <uuid/uuid.h>
const unsigned PJ_GUID_STRING_LENGTH=36;
PJ_DEF(pj_str_t*) pj_generate_unique_string(pj_str_t *str)
{
enum {GUID_LEN = 36};
char sguid[GUID_LEN + 1];
uuid_t uuid = {0};
PJ_ASSERT_RETURN(GUID_LEN <= PJ_GUID_STRING_LENGTH, NULL);
PJ_ASSERT_RETURN(str->ptr != NULL, NULL);
PJ_CHECK_STACK();
uuid_generate(uuid);
uuid_unparse(uuid, sguid);
pj_memcpy(str->ptr, sguid, GUID_LEN);
str->slen = GUID_LEN;
return str;
}